class AmbientCreature_Fish extends AmbientCreature placeable;

/* 
 * Action : fish ũ    
 *          
*/
var Bool bFalloff;                      // Ʒ  κ.
var Float BurstSpeed,OrigSpeed;         //  ӵ Ϲݼӵ
var Rotator BurstRotRate,OrigRotRate;   // ΰ ȸ, Ϲ ȸ
var Int BurstPercent;                   // ο   ν Ȯ


function PostBeginPlay()
{
	local Float RandVal;

	Super(Pawn).PostBeginPlay();

	SetDrawScale(RandRange(MinSize,MaxSize));   // ũ ũ
	RandVal = RandRange(0.5,1.5);

    RotationRate *= RandVal;                    //random speed/rotation rate high speed == high rotation rate    
	Speed *= RandVal;
	
	OrigRotRate = RotationRate;                 // Ϲ ȸ
	BurstRotRate = RotationRate * 4;            // ׹  νƮ ȸ
	
	OrigSpeed = Speed;                          // ӵ
	BurstSpeed = Speed * 4;                     // ׹  νƮ ӵ

	SetRandDest();                              // ũ  
}

//version that makes use of the BurstPercent variable to determine whether a burst should be performed
function SetRandDest()
{
	`log("Default.Speed = " $ Default.Speed);

	// ް.
	If(!bFalloff && (Rand(100) < BurstPercent))
	{
		Speed = BurstSpeed;
		RotationRate = BurstRotRate;
		bFalloff = True;//burst mode is on
	}
	Super.SetRandDest();
}



function Tick(Float Delta)
{
	//causing this increased speed to smoothly falloff back to the original speed
	If(bFalloff)
	{
		//Delta parameter value will be the amount of time that has passed since the last time the Tick was executed
		Speed -= BurstSpeed * Delta;
		RotationRate -= BurstRotRate * Delta;
		If(Speed <= OrigSpeed)
		{
			Speed = OrigSpeed;
			RotationRate = OrigRotRate;
			bFalloff = False;
			
			ClearTimer('SetRandDest');
			SetRandDest();  // ް  ο  
		}
	}
	Super.Tick(Delta);      
}


defaultproperties
{
	Speed=70
	MinSize=0.1
	MaxSize=0.25
	MinTraveltime=0.25
	MaxTravelTime=4.0
	RotationRate=(Pitch=16384,Yaw=16384,Roll=16384)
	BurstPercent=10
	
	Begin Object Name=MyStaticMesh
		StaticMesh=StaticMesh'Chapter_06_Functions.ClownFish'
	End Object
}
//speed value of 70 which after the random variation calculated in the PostBeginPlay() function will result in a speed from 35 to 105
//16384 rotation == 90 degrees
//10% chance of the fish having a burst
//MyStaticMesh defined in AmbientCreature.uc, define it's mesh here, note Begin Object line has no class= portion
//BIGGER FISH so i can see them


